#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""

@author: aaron

"""
import peak_list as pl

# ------- TEST CASES ------------------
# Some example test data defined below.
# You need to create some more of your own.
# Copy the format, but change the values.
# To change which test case is used, skip below to the main module.
def test1():
    """
    An example from the assignment spec.
    """
    data_series = [0, 0, -2, 2, -2, 2, 0, 1, 41, 38, 22, 10, -1, 3,-1, 2, -2, 3, 2, 3]
    smoothing = 8
    th = 3.0 
    influence = 0.0 
    expected_answer = [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0]
    

    return data_series, smoothing, th, influence, expected_answer

def test2():
    """
    The input series from the assignment spec repeated.
    """
    data_series = [0, 0, -2, 2, -2, 2, 0, 1, 41, 38, 22, 10, -1, 3,-1, 2, -2, 3, 2, 3, 0, 0, -2, 2, -2, 2, 0, 1, 41, 38, 22, 10, -1, 3,-1, 2, -2, 3, 2, 3]
    smoothing = 8
    th = 3.0 
    influence = 0.0 
    expected_answer = [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0]
    
    return data_series, smoothing, th, influence, expected_answer


def test3():
    """
    Something with a few more peaks 
    """
    data_series = [0,0,-2,2,-2,2,0, 1, 10, 15, 3, 0, 7, 9, 3 , 2, 7, 12, 2, 1]
    smoothing = 8
    th = 3.0 
    influence = 0.0 
    expected_answer = [0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0]
    

    return data_series, smoothing, th, influence, expected_answer



# --- CHECK OUTPUT ------------------
# This function compares the value of two lists.
# Check your output against expected output, and report the result
def check_output(result, expected_answer):

    # Let's check whether the parameters are lists or not?
    if not((type(result) is list) and (type(expected_answer) is list)):
        print("Error: invalid input for the function 'check_output' ")
        return

    # Let's print your output
    print('This is the output your function gave --> ', result)
    # Let's print expected output
    print('This is the expected output           --> ', expected_answer)

    if len(result) != len(expected_answer):
        print('Oh noooo, your output does NOT match expected output. Please try again.')
        return

    is_correct = True
    for i in range(0, len(expected_answer)):
        if abs(result[i] - expected_answer[i]) > 0.00001:
                is_correct = False

    if is_correct is True:
            print('GOOD JOB your output matches the expected outputs. YAY!!!!! =)')
    else:
            print('Oh noooo, your output does NOT match expected output. Please try again.')




# ---- MAIN MODULE --------------------
# This is the main code that performs the test
print('TESTING FUNCTION: peak_list')

# Select Your Test, you can select one at a time
# TODO change the test<number> to run a different test at a time

#data_series, smoothing, th, influence, expected_answer = test1()
#data_series, smoothing, th, influence, expected_answer = test2()
data_series, smoothing, th, influence, expected_answer = test3()


# Let's call your function!
result = pl.peak_list(data_series, smoothing, th, influence)

# Let's check your output against expected output, and report the result
check_output(result, expected_answer)

# -------- end ---------------
